using System;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;

namespace GoBusExperimental
{
    public class NetworkGoPortClient : GoPortBase
    {
        public NetworkGoPortClient(int id)
        {
            ID = id;
        }

        public override void SPIWrite(byte[] writeBuffer, int writeIndex, int writeLength)
        {
            NetworkGoHubClient hub = (NetworkGoHubClient)Hub;

            // Determine the SPI clock rate
            uint speed = GoBus.SPIEnumerationClockRate;
            if (BoundModule != null)
                speed = BoundModule.SPIClockRate;

            // Send the message to the server
            hub.SPIWrite(this, speed, writeBuffer, writeIndex, writeLength);
        }

        public override void SPIWriteRead(byte[] writeBuffer, byte[] readBuffer)
        {
            NetworkGoHubClient hub = (NetworkGoHubClient)Hub;

            // Determine the SPI clock rate
            uint speed = GoBus.SPIEnumerationClockRate;
            if (BoundModule != null)
                speed = BoundModule.SPIClockRate;

            // Send the message to the server
            hub.SPIWriteRead(this, speed, writeBuffer, readBuffer);
        }

        public override void SPIWriteRead(byte[] writeBuffer, int writeIndex, int writeLength, byte[] readBuffer, int readIndex, int readLength, int startReadOffset)
        {
            // TODO
            throw new NotImplementedException();
        }

        private GoPortGpioPinMode _gpioPinMode;
        public override GoPortGpioPinMode GpioPinMode
        {
            get { return _gpioPinMode; }
            set
            {
                _gpioPinMode = value;
                NetworkGoHubClient hub = (NetworkGoHubClient)Hub;
                hub.SetGpioPinMode(this, _gpioPinMode);
            }
        }
        public override bool GpioPinGlitchFilter { get; set; }
        public override PortResistorMode GpioPinResistorMode { get; set; }
        public override PortInterruptMode GpioPinInterruptMode { get; set; }

        public override void GpioWrite(bool value)
        {
            throw new NotImplementedException();
        }

        public override bool GpioRead()
        {
            throw new NotImplementedException();
        }

        internal new void SendOnGpioPinInterrupt(bool state)
        {
            base.SendOnGpioPinInterrupt(state);
        }

    }
}
