using System;

namespace GoBusExperimental
{
    public enum GoPortGpioPinMode
    {
        /// <summary>
        /// The GPIO pin will be unused.
        /// </summary>
        None = 0,

        /// <summary>
        /// Configure the GPIO pin as a general-purpose output port.
        /// </summary>
        Output = 1,

        /// <summary>
        /// Configure the GPIO pin as a general-purpose input port.
        /// </summary>
        Input = 2,

        /// <summary>
        /// Configure the GPIO pin as an interrupt-enabled input port.
        /// </summary>
        IRQ = 3,
    }

    public enum PortResistorMode
    {
        Disabled,
        PullDown,
        PullUp,
    }

    public enum PortInterruptMode
    {
        InterruptNone,
        InterruptEdgeLow,
        InterruptEdgeHigh,
        InterruptEdgeBoth,
        InterruptEdgeLevelHigh,
        InterruptEdgeLevelLow,
    }
}
