using System;

namespace GoBusExperimental
{
    public interface IGoPort
    {
        int ID { get; set; }
        IGoHub Hub { get; set; }
        void Initialize();
        Guid GetConnectedModuleGuid();

        GoModule BoundModule { get; }
        void Bind(GoModule module);
        void Unbind();

        void SPIWrite(byte[] writeBuffer);
        void SPIWrite(byte[] writeBuffer, int writeIndex, int writeLength);
        void SPIWriteRead(byte[] writeBuffer, byte[] readBuffer);
        void SPIWriteRead(byte[] writeBuffer, int writeIndex, int writeLength, byte[] readBuffer, int readIndex, int readLength, int startReadOffset);

        // TODO: Add UART Write/Read methods.

        GoPortGpioPinMode GpioPinMode { get; set; }
        bool GpioPinGlitchFilter { get; set; }
        PortResistorMode GpioPinResistorMode { get; set; }
        PortInterruptMode GpioPinInterruptMode { get; set; }
        void GpioWrite(bool value);
        bool GpioRead();
        event GpioEventHandler OnGpioPinInterrupt;
    }
}
