﻿using System;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using SecretLabs.NETMF.Hardware;
using SecretLabs.NETMF.Hardware.Netduino;
using GoBusExperimental;
using Komodex.NETMF;
using Microsoft.SPOT.Net.NetworkInformation;

namespace NetworkGoBusClientSample
{
    public class Program
    {
        public static void Main()
        {
            // Wait for network connection and DHCP
            while (IPAddress.GetDefaultLocalAddress() == IPAddress.Any)
                Thread.Sleep(10);
            Debug.Print("Got IP: " + IPAddress.GetDefaultLocalAddress());

            var hub = new NetworkGoHubClient(IPAddress.Parse("10.0.0.71"), 1234);
            var port = new NetworkGoPortClient(1);
            hub.AddGoPort(port);
            GoBus.AddHub(hub);

            var display1 = new SevenSegmentDisplay();
            var display2 = new SevenSegmentDisplay();

            var pot = new Potentiometer();

            double value;
            while (true)
            {
                value = pot.GetValue();
                display2.SetValue(value, 3);
                display1.SetValue(value, 3);
            }

        }
    }
}
